/****************************************************************************
Copyright 2010 Bilkent University

Licensed under the Apache License, Version 2.0 (the "License"); 
you may not use this file except in compliance with the License. 
You may obtain a copy of the License at 
http://www.apache.org/licenses/LICENSE-2.0 

Unless required by applicable law or agreed to in writing, software 
distributed under the License is distributed on an "AS IS" BASIS, 
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
See the License for the specific language governing permissions and 
limitations under the License. 
****************************************************************************/
#include "REng/Geom/GeomBox.h"

using namespace cml;

namespace REng{

	GeomBox::GeomBox() : mCornersDirty(true) {
		mPosition.set(0.0f,0.0f,0.0f);
		mHalfSize.set(0.5f,0.5f,0.5f);
	}
	const Vector3& GeomBox::getHalfSize() const{
		return mHalfSize;
	}
	Vector3 GeomBox::getSize() const{
		return mHalfSize*2;
	}
	float GeomBox::getVolume() const{
		Vector3 size = mHalfSize * 2;
		return size[0]*size[1]*size[2];
	}
	const GeomPoint* GeomBox::getCorners() const{
		if(mCornersDirty) updateCorners();
		return mCorners_cache;
	}

}
