//////////////////////////////////////////////////////////////////////////
// BODY
inline AutoSleep_Body::AutoSleep_Body() : mID(0) { }
inline void AutoSleep_Body::resetToWorldDefaults(){
	dBodySetAutoDisableDefaults(mID);
}
inline void AutoSleep_Body::setActive(bool enabled){
	dBodySetAutoDisableFlag(mID,enabled);
}
inline bool AutoSleep_Body::isActive() const{
	return dBodyGetAutoDisableFlag(mID)!=0;
}
inline void AutoSleep_Body::setLinearThres(Real linear_thres){
	dBodySetAutoDisableLinearThreshold(mID,linear_thres);
}
inline Real AutoSleep_Body::getLinearThres() const{
	return dBodyGetAutoDisableLinearThreshold(mID);
}
inline void AutoSleep_Body::setAngularThres(Real angular_thres){
	dBodySetAutoDisableAngularThreshold(mID,angular_thres);
}
inline Real AutoSleep_Body::getAngularThres() const{
	return dBodyGetAutoDisableAngularThreshold(mID);
}
inline void AutoSleep_Body::setLimitSteps(size_t steps){
	dBodySetAutoDisableSteps(mID,int(steps));
}
inline size_t AutoSleep_Body::getLimitSteps() const{
	return (size_t)dBodyGetAutoDisableSteps(mID);
}
inline void AutoSleep_Body::setAverageSamplesCount(size_t s){
	dBodySetAutoDisableAverageSamplesCount(mID,int(s));
}
inline size_t AutoSleep_Body::getAverageSamplesCount() const{
	return dBodyGetAutoDisableAverageSamplesCount(mID);
}
inline void AutoSleep_Body::setLimitSeconds(Real t){
	dBodySetAutoDisableTime(mID,t);
}
inline Real AutoSleep_Body::getLimitSeconds() const{
	return dBodyGetAutoDisableTime(mID);
}



//////////////////////////////////////////////////////////////////////////
// WORLD
inline AutoSleep_World::AutoSleep_World() : mID(0) { }
inline void AutoSleep_World::setActive(bool enabled){
	dWorldSetAutoDisableFlag(mID,enabled);
}
inline bool AutoSleep_World::isActive() const{
	return dWorldGetAutoDisableFlag(mID)!=0;
}
inline void AutoSleep_World::setLinearThres(Real linear_thres){
	dWorldSetAutoDisableLinearThreshold(mID,linear_thres);
}
inline Real AutoSleep_World::getLinearThres() const{
	return dWorldGetAutoDisableLinearThreshold(mID);
}
inline void AutoSleep_World::setAngularThres(Real angular_thres){
	dWorldSetAutoDisableAngularThreshold(mID,angular_thres);
}
inline Real AutoSleep_World::getAngularThres() const{
	return dWorldGetAutoDisableAngularThreshold(mID);
}
inline void AutoSleep_World::setLimitSteps(size_t steps){
	dWorldSetAutoDisableSteps(mID,int(steps));
}
inline size_t AutoSleep_World::getLimitSteps() const{
	return (size_t)dWorldGetAutoDisableSteps(mID);
}
inline void AutoSleep_World::setAverageSamplesCount(size_t s){
	dWorldSetAutoDisableAverageSamplesCount(mID,int(s));
}
inline size_t AutoSleep_World::getAverageSamplesCount() const{
	return dWorldGetAutoDisableAverageSamplesCount(mID);
}
inline void AutoSleep_World::setLimitSeconds(Real t){
	dWorldSetAutoDisableTime(mID,t);
}
inline Real AutoSleep_World::getLimitSeconds() const{
	return dWorldGetAutoDisableTime(mID);
}
