//////////////////////////////////////////////////////////////////////////
// BODY
//////////////////////////////////////////////////////////////////////////
inline Damping_Body::Damping_Body() : mID(0) { }
inline void Damping_Body::resetToWorldDefaults(){
	dBodySetDampingDefaults(mID);
}
inline void Damping_Body::setLinear(Real scale){
	dBodySetLinearDamping(mID,scale);
}
inline void Damping_Body::setAngular(Real scale){
	dBodySetAngularDamping(mID,scale);
}
inline void Damping_Body::setLinearThres(Real threshold){
	dBodySetLinearDampingThreshold(mID,threshold);
}
inline void Damping_Body::setAngularThres(Real threshold){
	dBodySetAngularDampingThreshold(mID,threshold);
}
inline Real Damping_Body::getLinear() const{
	return dBodyGetLinearDamping(mID);
}
inline Real Damping_Body::getAngular() const{
	return dBodyGetAngularDamping(mID);
}
inline Real Damping_Body::getLinearThres() const{
	return dBodyGetLinearDampingThreshold(mID);
}
inline Real Damping_Body::getAngularThres() const{
	return dBodyGetAngularDampingThreshold(mID);
}
inline void Damping_Body::setMaxSpeedAngular(Real speed){
	dBodySetMaxAngularSpeed(mID,speed);
}
inline Real Damping_Body::getMaxAngularSpeed() const{
	return dBodyGetMaxAngularSpeed(mID);
}

//////////////////////////////////////////////////////////////////////////
// WORLD
//////////////////////////////////////////////////////////////////////////
inline Damping_World::Damping_World() : mID(0) { }
inline void Damping_World::setLinear(Real damp_lin){
	dWorldSetLinearDamping(mID,damp_lin);
}
inline void Damping_World::setAngular(Real damp_ang){
	dWorldSetAngularDamping(mID,damp_ang);
}
inline Real Damping_World::getLinear() const{
	return dWorldGetLinearDamping(mID);
}
inline Real Damping_World::getAngular() const{
	return dWorldGetAngularDamping(mID);
}
inline void Damping_World::setLinearThres(Real damp_lin){
	dWorldSetLinearDampingThreshold(mID,damp_lin);
}
inline void Damping_World::setAngularThres(Real damp_ang){
	dWorldSetAngularDampingThreshold(mID,damp_ang);
}
inline Real Damping_World::getLinearThres() const{
	return dWorldGetLinearDampingThreshold(mID);
}
inline Real Damping_World::getAngularThres() const{
	return dWorldGetAngularDampingThreshold(mID);
}
inline void Damping_World::setMaxSpeedAngular(Real max_speed){
	dWorldSetMaxAngularSpeed(mID,max_speed);
}
inline Real Damping_World::getMaxAngularSpeed() const{
	return dWorldGetMaxAngularSpeed(mID);
}

